const {OD,OASGN,sign_str,add_repr} = require("nv-facutil-basic");
const _path                        = require("path");


const _str                         = require("nv-string-basic");
const _fbsc                        = require("nv-file-basic");
const _S                           = require("nv-server-simple-stream").http.simple;
const _chown_with_name             = require("nv-cli-user").chown_with_name;
const _rrequire                    = require("nv-facutil-rrequire");
const _cmmn                        = require("nv-remote-user-local-eng")._cmmn;

const _init_db                     = require("nv-loan-admin-db").init;

const {
    route_to_route_filename
}                                  = require("nv-cli-route");

const {
    DFLT_ROUTE_PREFIX,
    creat_routes
}  = require("nv-loan-admin-db");


const DFLT_404_HANDLE = async(D,res,srv) => {
    let r = await _S.reply_with_json(res,[-404,"正在升级中"]);
    return(r)
}



const DFLT_NGINX_USER = "www-data";
const DFLT_USOCK      = "___nv_loan_admin___";
const DFLT_DB_NAME    = "loan_admin";
const DFLT_TBL_NAME   = require("nv-loan-admin-db").DFLT_TBL_NAME;

const DFLT_VALIDATE = async(reqD,route,srv) => {
     let req_headers = reqD.headers;
     ////let req_body    = _cmmn.buf2json(reqD.body);
     let USER        = srv.cfg.USER;            //用户池
     let {u,ka}      = USER.tpool;
     let userid      = req_headers.utoken?u.get_userid(req_headers.utoken):undefined;
     if(userid) {
         let is_admin = (userid === '/___未划分___/admin');
         if(is_admin) {
             return([true,userid])
         } else if(route.includes("creat")) {
             return([true,userid])
         } else {
             return([false,"业务员只能【创建贷款】,其他操作必须使用管理员"])
         }
     } else {
         return([false,null])
     }
}


const DFLT_CFG = ()=>({
   ////
   USER:globalThis.USER,
   OSS:globalThis.OSS, 
   validate:DFLT_VALIDATE, 
   //// 
   sock:{ 
       nginx_user:DFLT_NGINX_USER,
       usock:DFLT_USOCK,
   },
   db:{ 
       dbname:DFLT_DB_NAME,
       tbl:DFLT_TBL_NAME,
       oss:globalThis.OSS.oss
   }
});


class Srv {
    cfg     = DFLT_CFG();
    srv     = null;
    db      = null;
    ////---
    handle_dict = {};
    set_handle(route,afunc,reload=false) {
       if(afunc === undefined) {
           let p = route_to_route_filename(route);
           if(reload) {
                this.handle_dict[route] = DFLT_404_HANDLE;
                _rrequire.unrequire("./route/"+p);
           } else {}
           this.handle_dict[route] = require("./route/"+p);
       } else {
           this.handle_dict[route] = afunc;
       }
   }
   ////
}


const ROUTES       = creat_routes(DFLT_ROUTE_PREFIX);

const creat_dbg_routes = (prefix=DFLT_ROUTE_PREFIX)=>{
    let k0 = `${DFLT_ROUTE_PREFIX}/debug/handle/list`;
    let k1 = `${DFLT_ROUTE_PREFIX}/debug/handle/change`;
    let d = {}
    d[k0]=route_to_route_filename(k0);
    d[k1]=route_to_route_filename(k1);
    return(d)
}

const DBG_ROUTES   = creat_dbg_routes(DFLT_ROUTE_PREFIX);
const FORBIDDEN    = Object.values(DBG_ROUTES); 
const PERSIST      = new Set(Object.keys(ROUTES)); 


async function creat(cfg=DFLT_CFG()) {
    let ncfg = OASGN(DFLT_CFG(),cfg);
    //--enable service:--
    let srv = new Srv();
    srv.cfg = ncfg;
    //--conn oss:----
    let OSS = srv.cfg.OSS
    srv.db = await _init_db(srv.cfg.db.dbname,srv.cfg.db.tbl,OSS.oss);
    // http-server
    srv.srv = await _S.creat(ncfg.sock.usock);
    add_repr(srv.srv.constructor,(that)=>that._pipeName);
    _chown_with_name(ncfg.sock.usock,ncfg.sock.nginx_user);
    //--- USER POOL---
    Object.defineProperty(srv,"USER_",    {get:function(){return(srv.cfg.USER    )}});
    Object.defineProperty(srv,"validate_",{get:function(){return(srv.cfg.validate)}});
    //--add debug routes
    for(let route in DBG_ROUTES) {   // {route:route-filename}
        srv.set_handle(route);
    }
    //--add biz  routes
    for(let route in ROUTES) {      // {route:method}
        srv.set_handle(route)
    }
    //handle wrap
    srv.srv.handler_ = async (req,res) => {
        let D     = await _S.extract_req_without_body(req);
        D["#req"] = req;
        let afunc = srv.handle_dict[D.path];
        if(afunc===undefined) {
            return(await _S.reply_with_json(res,null))
        } else {
            return(await afunc(D,res,srv));
        }
    }
    //
    return(srv)
}


module.exports = {
   DFLT_CFG,
   DFLT_VALIDATE,
   //// 
   ROUTES,
   DBG_ROUTES,
   FORBIDDEN,
   PERSIST,
   //// 
   Srv,
   creat,
}
